cdef extern from "inttypes.h":
    ctypedef int int32_t  
    ctypedef unsigned int uint32_t

cdef extern from "orgasm.h":
    ctypedef struct buffer_t:
        size_t         readSize        # Size of one read in base pair
        size_t         readCount       # count of reads. One pair of reads counts for 2
        uint32_t*      order1          # a pointer used to point on a int array indicating an order
                                       # over the records.
        uint32_t*      order2          # a pointer used to point on a int array indicating an order
                                       # over the records.
        
    ctypedef unsigned char* pnuc

cdef class Index:

    cdef buffer_t* _index
    cpdef bint contains(self, bytes word)
    cpdef int count(self,word)
    cpdef int len(self)
    cpdef bytes getRead(self, int32_t readid, int32_t begin, int32_t length)
    cpdef dict getExtensions(self, bytes word)
    cpdef int getReadSize(self)
    cpdef tuple getReadIds(self, bytes seq)
    cpdef int32_t getPairId(self,int32_t readid)
    